-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------
--  Hammer of Justas
--
-- Copyright (C) 2010-2020
-- By Jonathan E. Wright
--
-- FILE: HoJ_SpellInfos.lua
-- DESC: Spell tables for classes

local addonName, HoJ = ...

-- DEFAULT_CHAT_FRAME:AddMessage( "HoJ_SpellInfos.lua" )

--[[
TODO:
- remove cooldownRemaining -- it's unused
- remove _priorty and priorty after these are converted to explict priorty lists per bar
--]]

-- -------------------------------------------------------------
-- PALADIN
-- -------------------------------------------------------------
HoJ._paladinSpellInfos = {
    ["divinePurpose"] = {
        id = 223817,
        name = HoJ:GetSpellName( 223817 ),
        rank = HoJ:GetSpellRank( 223817 ),
        icon = HoJ:GetSpellIcon( 223817 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = true,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 7,
        talentCol = 1,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["divinePurposeBuff"] = {
        id = 223819,
        name = HoJ:GetSpellName( 223819 ),
        rank = HoJ:GetSpellRank( 223819 ),
        icon = HoJ:GetSpellIcon( 223819 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = true,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _priority = 900,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["righteousVerdict"] = {
        id = 267610,
        name = HoJ:GetSpellName( 267610 ),
        rank = HoJ:GetSpellRank( 267610 ),
        icon = HoJ:GetSpellIcon( 267610 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 80,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _duration = 20,
        talentRow = 1,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["righteousVerdictBuff"] = {
        id = 267611,
        name = HoJ:GetSpellName( 267611 ),
        rank = HoJ:GetSpellRank( 267611 ),
        icon = HoJ:GetSpellIcon( 267611 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT_BUFF,
        isProcd = true,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _priority = 910,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 1,
        talenCol = 2,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["inquisition"] = {
        id = 84963,
        name = HoJ:GetSpellName( 84963 ),
        rank = HoJ:GetSpellRank( 84963 ),
        icon = HoJ:GetSpellIcon( 84963 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT_BUFF,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        _showStacks = true,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _priority = 1500,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 7,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["avengingWrath"] = {
        id = 31884,
        name = HoJ:GetSpellName( 31884 ),
        rank = HoJ:GetSpellRank( 31884 ),
        icon = HoJ:GetSpellIcon( 31884 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 37,
        cooldownRemaining = 0,
        _priority = 2000,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _duration = 20,
    },
    ["crusade"] = {
        id = 231895,
        name = HoJ:GetSpellName( 231895 ),
        rank = HoJ:GetSpellRank( 231895 ),
        icon = HoJ:GetSpellIcon( 231895 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 80,
        cooldownRemaining = 0,
        _priority = 2000,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _duration = 20,
        talentRow = 7,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["seraphim"] = {
        id = 152262,
        name = HoJ:GetSpellName( 152262 ),
        rank = HoJ:GetSpellRank( 152262 ),
        icon = HoJ:GetSpellIcon( 152262 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT_BUFF,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        _showStacks = true,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _priority = 1750,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 5,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_PROTECTION }
    },
    ["divineProtection"] = {
        id = 498,
        name = HoJ:GetSpellName( 498 ),
        rank = HoJ:GetSpellRank( 498 ),
        icon = HoJ:GetSpellIcon( 498 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 26,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["ardentDefender"] = {
        id = 31850,
        name = HoJ:GetSpellName( 31850 ),
        rank = HoJ:GetSpellRank( 31850 ),
        icon = HoJ:GetSpellIcon( 31850 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 42,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["shieldOfTheRighteous"] = {
        id = 53600,
        name = HoJ:GetSpellName( 53600 ),
        rank = HoJ:GetSpellRank( 53600 ),
        icon = HoJ:GetSpellIcon( 53600 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 2,
        cooldownRemaining = 0,
        _priority = 5000,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
    },
    ["shieldOfTheRighteousBuff"] = {
        id = 132403,
        name = HoJ:GetSpellName( 132403 ),
        rank = HoJ:GetSpellRank( 132403 ),
        icon = HoJ:GetSpellIcon( 132403 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["consecration"] = {
        id = 26573,
        name = HoJ:GetSpellName( 26573 ),
        rank = HoJ:GetSpellRank( 26573 ),
        icon = HoJ:GetSpellIcon( 26573 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 6,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 1,
        range = HoJ.RANGE_10_YARDS,
        _duration = 12,
    },
    ["protConsecrationBuff"] = {
        id = 188370,
        name = HoJ:GetSpellName( 188370 ),
        rank = HoJ:GetSpellRank( 188370 ),
        icon = HoJ:GetSpellIcon( 188370 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 1,
        range = HoJ.RANGE_10_YARDS,
        _duration = 12,
        _talentSpecs = { HoJ.SPEC_PALADIN_PROTECTION },
        _castBySpellId = 26573, -- consecration
    },
    ["avengersValor"] = {
        id = 197561,
        name = HoJ:GetSpellName( 197561 ),
        rank = HoJ:GetSpellRank( 197561 ),
        icon = HoJ:GetSpellIcon( 197561 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = true,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 60,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SEKF,
        _duration = 15,
        role = HoJ.ROLE_TANK
    },
    ["guardianOfAncientKings"] = {
        id = 86659,
        name = HoJ:GetSpellName( 86659 ),
        rank = HoJ:GetSpellRank( 86659 ),
        icon = HoJ:GetSpellIcon( 86659 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 39,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["divineShield"] = {
        id = 642,
        name = HoJ:GetSpellName( 642 ),
        rank = HoJ:GetSpellRank( 642 ),
        icon = HoJ:GetSpellIcon( 642 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 6,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["righteousFury"] = {
        id = 25780,
        name = HoJ:GetSpellName( 25780 ),
        rank = HoJ:GetSpellRank( 25780 ),
        icon = HoJ:GetSpellIcon( 25780 ),
        spellIndex = -1,  -- HoJ:GetSpellIndex( 25780 ),
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 12,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["blessingOfProtection"] = {
        id = 1022,
        name = HoJ:GetSpellName( 1022 ),
        rank = HoJ:GetSpellRank( 1022 ),
        icon = HoJ:GetSpellIcon( 1022 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 41,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["blessingOfFreedom"] = {
        id = 1044,
        name = HoJ:GetSpellName( 1044 ),
        rank = HoJ:GetSpellRank( 1044 ),
        icon = HoJ:GetSpellIcon( 1044 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 22,
        cooldownRemaining = 0,
        _priority = 1,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["blessingOfSacrifice"] = {
        id = 6940,
        name = HoJ:GetSpellName( 6940 ),
        rank = HoJ:GetSpellRank( 6940 ),
        icon = HoJ:GetSpellIcon( 6940 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 32,
        cooldownRemaining = 0,
        _priority = 1,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["hammerOfWrath"] = {
        id = 24275,
        name = HoJ:GetSpellName( 24275 ),
        rank = HoJ:GetSpellRank( 24275 ),
        icon = HoJ:GetSpellIcon( 24275 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 43,
        cooldownRemaining = 0,
        _priority = 800,
        _powerGen = 1,
        range = HoJ.RANGE_30_YARDS,
    },
    ["hammerOfWrath2"] = { -- rank 2, gained at level 58
        id = 326730,
        name = HoJ:GetSpellName( 326730 ),
        rank = HoJ:GetSpellRank( 326730 ),
        icon = HoJ:GetSpellIcon( 326730 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 58,
        cooldownRemaining = 0,
        _priority = 800,
        _powerGen = 1,
        range = HoJ.RANGE_30_YARDS,
    },
    ["rebuke"] = {
        id = 96231,
        name = HoJ:GetSpellName( 96231 ),
        rank = HoJ:GetSpellRank( 96231 ),
        icon = HoJ:GetSpellIcon( 96231 ),
        spellIndex = -1,  -- HoJ:GetSpellIndex( 96231 ),
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 23,
        cooldownRemaining = 0,
        _priority = 10000,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE
    },
    ["crusaderStrike"] = {
        id = 35395,
        name = HoJ:GetSpellName( 35395 ),
        rank = HoJ:GetSpellRank( 35395 ),
        icon = HoJ:GetSpellIcon( 35395 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _priority = 600,
        _powerGen = 1,
        range = HoJ.RANGE_MELEE
    },
    ["judgment"] = {
        id = 20271,
        name = HoJ:GetSpellName( 20271 ),
        rank = HoJ:GetSpellRank( 20271 ),
        icon = HoJ:GetSpellIcon( 20271 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 3,
        cooldownRemaining = 0,
        _priority = 400,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["judgmentDebuff"] = {
        id = 197277,
        name = HoJ:GetSpellName( 197277 ),
        rank = HoJ:GetSpellRank( 197277 ),
        icon = HoJ:GetSpellIcon( 197277 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 5,
        cooldownRemaining = 0,
        _priority = 400,
        _powerGen = 1,
        range = HoJ.RANGE_30_YARDS
    },
    ["templarsVerdict"] = {
        id = 85256,
        name = HoJ:GetSpellName( 85256 ),
        rank = HoJ:GetSpellRank( 85256 ),
        icon = HoJ:GetSpellIcon( 85256 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _priority = 1400,
        _powerGen = -3,
        range = HoJ.RANGE_MELEE
    },
    ["templarsVerdictDamage"] = { -- this is the spell we get in the combat log when TV hits an enemy.
        id = 224266,
        name = HoJ:GetSpellName( 224266 ),
        rank = HoJ:GetSpellRank( 224266 ),
        icon = HoJ:GetSpellIcon( 224266 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _priority = 1400,
        _powerGen = -3,
        range = HoJ.RANGE_MELEE
    },
    ["finalVerdict"] = {
        id = 157048,
        name = HoJ:GetSpellName( 157048 ),
        rank = HoJ:GetSpellRank( 157048 ),
        icon = HoJ:GetSpellIcon( 157048 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _priority = 1400,
        _powerGen = -3,
        range = HoJ.RANGE_MELEE
    },
    ["finalVerdictBuff"] = {	-- this skill is also the buff...
        id = 157048,
        name = HoJ:GetSpellName( 157048 ),
        rank = HoJ:GetSpellRank( 157048 ),
        icon = HoJ:GetSpellIcon( 157048 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = true,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _priority = 100,
        _powerGen = 0,
        range = HoJ.RANGE_NONE
    },
    ["divineStorm"] = {
        id = 53385,
        name = HoJ:GetSpellName( 53385 ),
        rank = HoJ:GetSpellRank( 53385 ),
        icon = HoJ:GetSpellIcon( 53385 ),
        spellIndex = -1,  -- HoJ:GetSpellIndex( 53385 ),
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 23,
        cooldownRemaining = 0,
        _priority = 1300,
        _powerGen = -3,
        range = HoJ.RANGE_12_YARDS
    },
    ["executionSentence"] = {
        id = 267798,
        name = HoJ:GetSpellName( 267798 ),
        rank = HoJ:GetSpellRank( 267798 ),
        icon = HoJ:GetSpellIcon( 267798 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 15,
        cooldownRemaining = 0,
        _priority = 1500,
        _powerGen = -3,
        range = HoJ.RANGE_20_YARDS,
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["lightsHammer"] = {
        id = 114158,
        name = HoJ:GetSpellName( 114158 ),
        rank = HoJ:GetSpellRank( 114158 ),
        icon = HoJ:GetSpellIcon( 114158 ),
        spellIndex = -1,  -- HoJ:GetSpellIndex( 114158 ),
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _priority = 1500,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["globalCooldown"] = {
        id = 61304,
        name = HoJ:GetSpellName( 61304 ),
        rank = HoJ:GetSpellRank( 61304 ),
        icon = HoJ:GetSpellIcon( 61304 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_NONE
    },
    ["selflessHealer"] = {
        id = 85804,
        name = HoJ:GetSpellName( 85804 ),
        rank = HoJ:GetSpellRank( 85804 ),
        icon = HoJ:GetSpellIcon( 85804 ),
        spellToCast = 19750, -- cast as flash of light
        spellIndex = -1,  -- HoJ:GetSpellIndex( 85804 ),
        spellType = HoJ.SPELL_TALENT_BUFF,
        isProcd = true,
        showOnBar = true, 	-- set to false so we don't show on the buffs bar by default, because we show on cooldowns due to the special circumstances
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 0,
        cooldownRemaining = 0,
        _priority = 500,
        _powerGen = 0,
        range = HoJ.RANGE_NONE,
        talentRow = 6,
        talentCol = 1,
        maxBuffCount = 4,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["selflessHealerBuff"] = {
        id = 114250,
        name = HoJ:GetSpellName( 114250 ),
        rank = HoJ:GetSpellRank( 114250 ),
        icon = HoJ:GetSpellIcon( 114250 ),
        spellToCast = 19750, -- cast as flash of light
        spellIndex = -1,  -- HoJ:GetSpellIndex( 85804 ),
        spellType = HoJ.SPELL_BUFF,
        isProcd = true,
        showOnBar = true, 	-- set to false so we don't show on the buffs bar by default, because we show on cooldowns due to the special circumstances
        showCheckbox = true,
        showCharges = false,
        _showStacks = true,
        text = nil,
        minLevel = 0,
        cooldownRemaining = 0,
        _priority = 1000,
        _powerGen = 0,
        range = HoJ.RANGE_NONE,
        talentRow = 6,
        talentCol = 1,
        maxBuffCount = 4,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["layOnHands"] = {
        id = 633,
        name = HoJ:GetSpellName( 633 ),
        rank = HoJ:GetSpellRank( 633 ),
        icon = HoJ:GetSpellIcon( 633 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 9,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["redemption"] = {
        id = 7328,
        name = HoJ:GetSpellName( 7328 ),
        rank = HoJ:GetSpellRank( 7328 ),
        icon = HoJ:GetSpellIcon( 7328 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 13,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["handOfReckoning"] = {
        id = 62124,
        name = HoJ:GetSpellName( 62124 ),
        rank = HoJ:GetSpellRank( 62124 ),
        icon = HoJ:GetSpellIcon( 62124 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["handOfHindrance"] = {
        id = 183218,
        name = HoJ:GetSpellName( 183218 ),
        rank = HoJ:GetSpellRank( 183218 ),
        icon = HoJ:GetSpellIcon( 183218 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["turnEvil"] = {
        id = 10326,
        name = HoJ:GetSpellName( 10326 ),
        rank = HoJ:GetSpellRank( 10326 ),
        icon = HoJ:GetSpellIcon( 10326 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 17,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["divineSteed"] = {
        id = 190784,
        name = HoJ:GetSpellName( 190784 ),
        rank = HoJ:GetSpellRank( 190784 ),
        icon = HoJ:GetSpellIcon( 190784 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 18,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["crusaderAura"] = {
        id = 32223,
        name = HoJ:GetSpellName( 32223 ),
        rank = HoJ:GetSpellRank( 32223 ),
        icon = HoJ:GetSpellIcon( 32223 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 21,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["devotionAura"] = {
        id = 465,
        name = HoJ:GetSpellName( 465 ),
        rank = HoJ:GetSpellRank( 465 ),
        icon = HoJ:GetSpellIcon( 465 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 28,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["retributionAura"] = {
        id = 183435,
        name = HoJ:GetSpellName( 183435 ),
        rank = HoJ:GetSpellRank( 183435 ),
        icon = HoJ:GetSpellIcon( 183435 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 38,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["concentrationAura"] = {
        id = 317920,
        name = HoJ:GetSpellName( 317920 ),
        rank = HoJ:GetSpellRank( 317920 ),
        icon = HoJ:GetSpellIcon( 317920 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 52,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["senseUndead"] = {
        id = 5502,
        name = HoJ:GetSpellName( 5502 ),
        rank = HoJ:GetSpellRank( 5502 ),
        icon = HoJ:GetSpellIcon( 5502 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 54,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_100_YARDS
    },
    ["hammerOfJustice"] = {
        id = 853,
        name = HoJ:GetSpellName( 853 ),
        rank = HoJ:GetSpellRank( 853 ),
        icon = HoJ:GetSpellIcon( 853 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 5,
        cooldownRemaining = 0,
        _priority = 7000,
        _powerGen = 0,
        range = HoJ.RANGE_10_YARDS
    },
    ["fistOfJustice"] = {
        id = 234299,
        name = HoJ:GetSpellName( 234299 ),
        rank = HoJ:GetSpellRank( 234299 ),
        icon = HoJ:GetSpellIcon( 234299 ),
        iconId = 853,
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _priority = 7000,
        _powerGen = 0,
        range = HoJ.RANGE_10_YARDS,
        talentRow = 3,
        talentCol = 1,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION, HoJ.SPEC_PALADIN_PROTECTION, HoJ.SPEC_PALADIN_HOLY }
    },
    ["blindingLight"] = {
        id = 115750,
        name = HoJ:GetSpellName( 115750 ),
        rank = HoJ:GetSpellRank( 115750 ),
        icon = HoJ:GetSpellIcon( 115750 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _priority = 6000,
        _powerGen = 0,
        range = HoJ.RANGE_10_YARDS,
        talentRow = 3,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION, HoJ.SPEC_PALADIN_PROTECTION, HoJ.SPEC_PALADIN_HOLY }
    },
    ["flashOfLight"] = {
        id = 19750,
        name = HoJ:GetSpellName( 19750 ),
        rank = HoJ:GetSpellRank( 19750 ),
        icon = HoJ:GetSpellIcon( 19750 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 4,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS
    },
    ["giftOfTheNaaru"] = {
        id = 59542,
        name = HoJ:GetSpellName( 59542 ),
        rank = HoJ:GetSpellRank( 59542 ),
        icon = HoJ:GetSpellIcon( 59542 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS,
        requiredRaceId = 11
    },
    ["wakeOfAshes"] = {
        id = 255937,
        name = HoJ:GetSpellName( 255937 ),
        rank = HoJ:GetSpellRank( 255937 ),
        icon = HoJ:GetSpellIcon( 255937 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 34,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 3,
        range = HoJ.RANGE_12_YARDS,
    },
    ["bladeOfJustice"] = {
        id = 184575,
        name = HoJ:GetSpellName( 184575 ),
        rank = HoJ:GetSpellRank( 184575 ),
        icon = HoJ:GetSpellIcon( 184575 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 2,
        range = HoJ.RANGE_12_YARDS
    },
    ["empyreanPower"] = {
        id = 326732,
        name = HoJ:GetSpellName( 326732 ),
        rank = HoJ:GetSpellRank( 326732 ),
        iconId = 326732,
        icon = HoJ:GetSpellIcon( 326732 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_12_YARDS,
        talentRow = 2,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["empyreanPowerBuff"] = {
        id = 326733,
        name = HoJ:GetSpellName( 326733 ),
        rank = HoJ:GetSpellRank( 326733 ),
        -- iconId = 326732, -- shows the empyrean power icon in the skill window
        icon = HoJ:GetSpellIcon( 326733 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _priority = 800,
        _powerGen = 0,
        range = HoJ.RANGE_12_YARDS
    },
    ["wordOfGlory"] = {
        id = 85673,
        name = HoJ:GetSpellName( 85673 ),
        rank = HoJ:GetSpellRank( 85673 ),
        icon = HoJ:GetSpellIcon( 85673 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 7,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = -3,
        range = HoJ.RANGE_40_YARDS,
    },
    ["justicarsVengeance"] = {
        id = 215661,
        name = HoJ:GetSpellName( 215661 ),
        rank = HoJ:GetSpellRank( 215661 ),
        icon = HoJ:GetSpellIcon( 215661 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = -5,
        range = HoJ.RANGE_40_YARDS,
        talentRow = 6,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["shieldOfVengeance"] = {
        id = 184662,
        name = HoJ:GetSpellName( 184662 ),
        rank = HoJ:GetSpellRank( 184662 ),
        icon = HoJ:GetSpellIcon( 184662 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 26,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["avengersShield"] = {
        id = 31935,
        name = HoJ:GetSpellName( 31935 ),
        rank = HoJ:GetSpellRank( 31935 ),
        icon = HoJ:GetSpellIcon( 31935 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _priority = 9000,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["hammerOfTheRighteous"] = {
        id = 53595,
        name = HoJ:GetSpellName( 53595 ),
        rank = HoJ:GetSpellRank( 53595 ),
        icon = HoJ:GetSpellIcon( 53595 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
    },
    ["blessedHammer"] = {
        id = 204019,
        name = HoJ:GetSpellName( 204019 ),
        rank = HoJ:GetSpellRank( 204019 ),
        icon = HoJ:GetSpellIcon( 204019 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 15,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_10_YARDS, -- this is a rough guess, but it appears to be about the same as Hammer of Justice
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_PROTECTION }
    },
    ["forbearance"] = {
        id = 25771,
        name = HoJ:GetSpellName( 25771 ),
        rank = HoJ:GetSpellRank( 25771 ),
        icon = HoJ:GetSpellIcon( 25771 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 15,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["repentance"] = {
        id = 20066,
        name = HoJ:GetSpellName( 20066 ),
        rank = HoJ:GetSpellRank( 20066 ),
        icon = HoJ:GetSpellIcon( 20066 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
        talentRow = 3,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_PALADIN_HOLY, HoJ.SPEC_PALADIN_PROTECTION, HoJ.SPEC_PALADIN_RETRIBUTION },
        _creatureTypes = { ["Demon"] = true, ["Humanoid"] = true, ["Undead"] = true, ["Dragonkin"] = true, ["Giant"] = true }
    },
    ["momentOfGlory"] = {
        id = 327193,
        name = HoJ:GetSpellName( 327193 ),
        rank = HoJ:GetSpellRank( 327193 ),
        icon = HoJ:GetSpellIcon( 327193 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 25,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 2,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_PALADIN_PROTECTION }
    },
    ["shiningLight"] = {
        id = 321136,
        name = HoJ:GetSpellName( 321136 ),
        rank = HoJ:GetSpellRank( 321136 ),
        icon = HoJ:GetSpellIcon( 321136 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL, -- passive
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 47,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["shiningLightBuff"] = {
        id = 182104,
        name = HoJ:GetSpellName( 182104 ),
        rank = HoJ:GetSpellRank( 182104 ),
        icon = HoJ:GetSpellIcon( 182104 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = true,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        _showStacks = true,
        text = nil,
        minLevel = 47,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
}

-- -------------------------------------------------------------
-- WARRIOR
-- -------------------------------------------------------------
HoJ._warriorSpellInfos = {
    ["globalCooldown"] = {
        id = 61304,
        name = HoJ:GetSpellName( 61304 ),
        rank = HoJ:GetSpellRank( 61304 ),
        icon = HoJ:GetSpellIcon( 61304 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_NONE
    },
    ["slam"] = {
        id = 1464,
        name = HoJ:GetSpellName( 1464 ),
        rank = HoJ:GetSpellRank( 1464 ),
        icon = HoJ:GetSpellIcon( 1464 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = -20,
        range = HoJ.RANGE_MELEE
    },
    ["colossusSmash"] = {
        id = 167105,
        name = HoJ:GetSpellName( 167105 ),
        rank = HoJ:GetSpellRank( 167105 ),
        icon = HoJ:GetSpellIcon( 167105 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE
    },
    ["colossusSmashBuff"] = { -- this is the buff the warrior gets after using colossus smash
        id = 167105,
        name = HoJ:GetSpellName( 167105 ),
        rank = HoJ:GetSpellRank( 167105 ),
        icon = HoJ:GetSpellIcon( 167105 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _priority = 900,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS },
        _duration = 15,
        _showStacks = true,
    },
    ["warbreakerDebuff"] = { -- this is the buff the target gets after the warrior uses warbreaker
        id = 208086,
        name = HoJ:GetSpellName( 208086 ),
        rank = HoJ:GetSpellRank( 208086 ),
        icon = HoJ:GetSpellIcon( 208086 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _priority = 900,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS },
        _duration = 15,
        _showStacks = true,
    },
    ["hamstring"] = {
        id = 1715,
        name = HoJ:GetSpellName( 1715 ),
        rank = HoJ:GetSpellRank( 1715 ),
        icon = HoJ:GetSpellIcon( 1715 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 32,
        cooldownRemaining = 0,
        _powerGen = -10,
        range = HoJ.RANGE_MELEE
    },
    ["victoryRush"] = {
        id = 34428,
        name = HoJ:GetSpellName( 34428 ),
        rank = HoJ:GetSpellRank( 34428 ),
        icon = HoJ:GetSpellIcon( 34428 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 5,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS, HoJ.SPEC_WARRIOR_FURY, HoJ.SPEC_WARRIOR_PROTECTION },
    },
    ["execute"] = {
        id = 5308,
        name = HoJ:GetSpellName( 5308 ),
        rank = HoJ:GetSpellRank( 5308 ),
        icon = HoJ:GetSpellIcon( 5308 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 8,
        cooldownRemaining = 0,
        _powerGen = 8,
        range = HoJ.RANGE_MELEE
    },
    ["armsExecute"] = {
        id = 163201,
        name = HoJ:GetSpellName( 163201 ),
        rank = HoJ:GetSpellRank( 163201 ),
        icon = HoJ:GetSpellIcon( 163201 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 8,
        cooldownRemaining = 0,
        _powerGen = -40,
        range = HoJ.RANGE_MELEE
    },
    ["armsExecuteWithMassacre"] = {
        id = 281000,
        name = HoJ:GetSpellName( 281000 ),
        rank = HoJ:GetSpellRank( 281000 ),
        icon = HoJ:GetSpellIcon( 281000 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 8,
        cooldownRemaining = 0,
        _powerGen = -40,
        range = HoJ.RANGE_MELEE
    },
    ["mortalStrike"] = {
        id = 12294,
        name = HoJ:GetSpellName( 12294 ),
        rank = HoJ:GetSpellRank( 12294 ),
        icon = HoJ:GetSpellIcon( 12294 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = -30,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS }
    },
    ["sweepingStrikes"] = {
        id = 260708,
        name = HoJ:GetSpellName( 260708 ),
        rank = HoJ:GetSpellRank( 260708 ),
        icon = HoJ:GetSpellIcon( 260708 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 22,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_8_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS },
        _duration = 12.0
    },
    ["bloodthirst"] = {
        id = 23881,
        name = HoJ:GetSpellName( 23881 ),
        rank = HoJ:GetSpellRank( 23881 ),
        icon = HoJ:GetSpellIcon( 23881 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = 8,
        range = HoJ.RANGE_MELEE
    },
    ["rampage"] = {
        id = 184367,
        name = HoJ:GetSpellName( 184367 ),
        rank = HoJ:GetSpellRank( 184367 ),
        icon = HoJ:GetSpellIcon( 184367 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 12,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    ["taunt"] = {
        id = 355,
        name = HoJ:GetSpellName( 355 ),
        rank = HoJ:GetSpellRank( 355 ),
        icon = HoJ:GetSpellIcon( 355 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 13,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS, HoJ.SPEC_WARRIOR_FURY, HoJ.SPEC_WARRIOR_PROTECTION }
    },
    ["heroicThrow"] = {
        id = 57755,
        name = HoJ:GetSpellName( 57755 ),
        rank = HoJ:GetSpellRank( 57755 ),
        icon = HoJ:GetSpellIcon( 57755 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 17,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS
    },
    ["berserkerRage"] = {
        id = 18499,
        name = HoJ:GetSpellName( 18499 ),
        rank = HoJ:GetSpellRank( 18499 ),
        icon = HoJ:GetSpellIcon( 18499 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 44,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _priority = 1
    },
    ["enrage"] = {
        id = 184361,
        name = HoJ:GetSpellName( 184361 ),
        rank = HoJ:GetSpellRank( 184361 ),
        icon = HoJ:GetSpellIcon( 184361 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["furyEnrageBuff"] = {
        id = 184362,
        name = HoJ:GetSpellName( 184362 ),
        rank = HoJ:GetSpellRank( 184362 ),
        icon = HoJ:GetSpellIcon( 184362 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },    
    ["ragingBlow"] = {
        id = 85288,
        name = HoJ:GetSpellName( 85288 ),
        rank = HoJ:GetSpellRank( 85288 ),
        icon = HoJ:GetSpellIcon( 85288 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _powerGen = 12,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    ["cleanseToxins"] = {
        id = 213644,
        name = HoJ:GetSpellName( 213644 ),
        rank = HoJ:GetSpellRank( 213644 ),
        icon = HoJ:GetSpellIcon( 213644 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 12,
        cooldownRemaining = 0,
        _priority = 700,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS,
        _talentSpecs = { HoJ.SPEC_PALADIN_RETRIBUTION }
    },
    ["pummel"] = {
        id = 6552,
        name = HoJ:GetSpellName( 6552 ),
        rank = HoJ:GetSpellRank( 6552 ),
        icon = HoJ:GetSpellIcon( 6552 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 24,
        cooldownRemaining = 0,
        _priority = 800,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS, HoJ.SPEC_WARRIOR_FURY, HoJ.SPEC_WARRIOR_PROTECTION }
    },
    ["whirlwind"] = {
        id = 190411,
        name = HoJ:GetSpellName( 190411 ),
        rank = HoJ:GetSpellRank( 190411 ),
        icon = HoJ:GetSpellIcon( 190411 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    ["armsWhirlwind"] = {
        id = 1680,
        name = HoJ:GetSpellName( 1680 ),
        rank = HoJ:GetSpellRank( 1680 ),
        icon = HoJ:GetSpellIcon( 1680 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = -30,
        range = HoJ.RANGE_8_YARDS,
        -- _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS }
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS, HoJ.SPEC_WARRIOR_FURY, HoJ.SPEC_WARRIOR_PROTECTION }
    },
    ["whirlwindBuff"] = {
        id = 85739,
        name = HoJ:GetSpellName( 85739 ),
        rank = HoJ:GetSpellRank( 85739 ),
        icon = HoJ:GetSpellIcon( 85739 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        _showStacks = true,
    },
    ["charge"] = {
        id = 100,
        name = HoJ:GetSpellName( 100 ),
        rank = HoJ:GetSpellRank( 100 ),
        icon = HoJ:GetSpellIcon( 100 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 3,
        cooldownRemaining = 0,
        _powerGen = 20,
        range = HoJ.RANGE_25_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS, HoJ.SPEC_WARRIOR_FURY }
    },
    ["heroicLeap"] = {
        id = 6544,
        name = HoJ:GetSpellName( 6544 ),
        rank = HoJ:GetSpellRank( 6544 ),
        icon = HoJ:GetSpellIcon( 6544 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 26,
        cooldownRemaining = 0,
        _priority = 700,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS, HoJ.SPEC_WARRIOR_FURY, HoJ.SPEC_WARRIOR_PROTECTION }
    },
    ["piercingHowl"] = {
        id = 12323,
        name = HoJ:GetSpellName( 12323 ),
        rank = HoJ:GetSpellRank( 12323 ),
        icon = HoJ:GetSpellIcon( 12323 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 32,
        cooldownRemaining = 0,
        _priority = 400,
        _powerGen = 15,
        range = HoJ.RANGE_15_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    ["enragedRegeneration"] = {
        id = 184364,
        name = HoJ:GetSpellName( 184364 ),
        rank = HoJ:GetSpellRank( 184364 ),
        icon = HoJ:GetSpellIcon( 184364 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 36,
        cooldownRemaining = 0,
        _priority = 1000,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    ["battleShout"] = {
        id = 6673,
        name = HoJ:GetSpellName( 6673 ),
        rank = HoJ:GetSpellRank( 6673 ),
        icon = HoJ:GetSpellIcon( 6673 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        buffDurationSeconds = 3600,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 42,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_100_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS, HoJ.SPEC_WARRIOR_FURY, HoJ.SPEC_WARRIOR_PROTECTION },
        _priority = 50,
    },
    ["recklessness"] = { -- this is also the same ID for the buff
        id = 1719,
        name = HoJ:GetSpellName( 1719 ),
        rank = HoJ:GetSpellRank( 1719 ),
        icon = HoJ:GetSpellIcon( 1719 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _priority = 2000,
        _powerGen = 100,
        range = HoJ.RANGE_SELF,
        _duration = 14
    },
    ["armsBladestorm"] = {
        id = 227847,
        name = HoJ:GetSpellName( 227847 ),
        rank = HoJ:GetSpellRank( 227847 ),
        icon = HoJ:GetSpellIcon( 227847 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 65,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_8_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS }
    },
    ["dieByTheSword"] = {
        id = 118038,
        name = HoJ:GetSpellName( 118038 ),
        rank = HoJ:GetSpellRank( 118038 ),
        icon = HoJ:GetSpellIcon( 118038 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 36,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 6,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS },
        _priority = 2500
    },
    ["overpower"] = {
        id = 7384,
        name = HoJ:GetSpellName( 7384 ),
        rank = HoJ:GetSpellRank( 7384 ),
        icon = HoJ:GetSpellIcon( 7384 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 6,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS },
        _showStacks = true,
    },
    -- talents
    ["armsSuddenDeath"] = {
        id = 29725,
        name = HoJ:GetSpellName( 29725 ),
        rank = HoJ:GetSpellRank( 29725 ),
        icon = HoJ:GetSpellIcon( 29725 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 15,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 1,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS }
    },
    ["armsSuddenDeathBuff"] = {
        id = 52437,
        name = HoJ:GetSpellName( 52437 ),
        rank = HoJ:GetSpellRank( 52437 ),
        icon = HoJ:GetSpellIcon( 52437 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
    },
    ["skullSplitter"] = {
        id = 260643,
        name = HoJ:GetSpellName( 260643 ),
        rank = HoJ:GetSpellRank( 260643 ),
        icon = HoJ:GetSpellIcon( 260643 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 15,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS }
    },
    ["impendingVictory"] = {
        id = 202168,
        name = HoJ:GetSpellName( 202168 ),
        rank = HoJ:GetSpellRank( 202168 ),
        icon = HoJ:GetSpellIcon( 202168 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _powerGen = -10,
        range = HoJ.RANGE_MELEE,
        talentRow = 3,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    ["stormBolt"] = {
        id = 107570,
        name = HoJ:GetSpellName( 107570 ),
        rank = HoJ:GetSpellRank( 107570 ),
        icon = HoJ:GetSpellIcon( 107570 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _priority = 700,
        _powerGen = 0,
        range = HoJ.RANGE_20_YARDS,
        talentRow = 2,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    ["armsMassacre"] = {
        id = 281001,
        name = HoJ:GetSpellName( 281001 ),
        rank = HoJ:GetSpellRank( 281001 ),
        icon = HoJ:GetSpellIcon( 281001 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 3,
        talentCol = 1,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS }
    },
    ["fervorOfBattle"] = {
        id = 202316,
        name = HoJ:GetSpellName( 202316 ),
        rank = HoJ:GetSpellRank( 202316 ),
        icon = HoJ:GetSpellIcon( 202316 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 3,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS }
    },
    ["rend"] = {
        id = 772,
        name = HoJ:GetSpellName( 772 ),
        rank = HoJ:GetSpellRank( 772 ),
        icon = HoJ:GetSpellIcon( 772 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _powerGen = -30,
        range = HoJ.RANGE_SELF,
        talentRow = 3,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS }
    },
    ["rendDebuff"] = {
        id = 772,
        name = HoJ:GetSpellName( 772 ),
        rank = HoJ:GetSpellRank( 772 ),
        icon = HoJ:GetSpellIcon( 772 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _priority = 900,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 3,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY },
        _duration = 15,
        _showStacks = true,
    },
    ["furySuddenDeath"] = {
        id = 280721,
        name = HoJ:GetSpellName( 280721 ),
        rank = HoJ:GetSpellRank( 280721 ),
        icon = HoJ:GetSpellIcon( 280721 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 3,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    ["furySuddenDeathBuff"] = {
        id = 280776,
        name = HoJ:GetSpellName( 280776 ),
        rank = HoJ:GetSpellRank( 280776 ),
        icon = HoJ:GetSpellIcon( 280776 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
    },
    ["furiousSlash"] = {
        id = 100130,
        name = HoJ:GetSpellName( 100130 ),
        rank = HoJ:GetSpellRank( 100130 ),
        icon = HoJ:GetSpellIcon( 100130 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 3,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY },
    },
    ["furiousSlashBuff"] = { -- this is the buff the warrior gets after using furious slash
        id = 202539,
        name = HoJ:GetSpellName( 202539 ),
        rank = HoJ:GetSpellRank( 202539 ),
        icon = HoJ:GetSpellIcon( 202539 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _priority = 900,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 3,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY },
        _duration = 15,
        _showStacks = true,
    },
    ["shockwave"] = {
        id = 46968,
        name = HoJ:GetSpellName( 46968 ),
        rank = HoJ:GetSpellRank( 46968 ),
        icon = HoJ:GetSpellIcon( 46968 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 50,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_10_YARDS,
        _priority = 700,
    },
    ["furyMassacre"] = {
        id = 206315,
        name = HoJ:GetSpellName( 206315 ),
        rank = HoJ:GetSpellRank( 206315 ),
        icon = HoJ:GetSpellIcon( 206315 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 75,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 5,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    ["intimidatingShout"] = {
        id = 5246,
        name = HoJ:GetSpellName( 5246 ),
        rank = HoJ:GetSpellRank( 5246 ),
        icon = HoJ:GetSpellIcon( 5246 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 70,
        cooldownRemaining = 0,
        _priority = 600,
        _powerGen = 0,
        range = HoJ.RANGE_8_YARDS, -- test show this is actually 10 yards
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS, HoJ.SPEC_WARRIOR_FURY, HoJ.SPEC_WARRIOR_PROTECTION }
    },
    ["menace"] = {
        id = 275338,
        name = HoJ:GetSpellName( 275338 ),
        rank = HoJ:GetSpellRank( 275338 ),
        icon = HoJ:GetSpellIcon( 275338 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 75,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_8_YARDS,
        talentRow = 5,
        talentCol = 1,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION }
    },
    ["warbreaker"] = {
        id = 262161,
        name = HoJ:GetSpellName( 262161 ),
        rank = HoJ:GetSpellRank( 262161 ),
        icon = HoJ:GetSpellIcon( 262161 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 75,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_8_YARDS,
        talentRow = 5,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS }
    },
    ["avatar"] = {
        id = 107574,
        name = HoJ:GetSpellName( 107574 ),
        rank = HoJ:GetSpellRank( 107574 ),
        icon = HoJ:GetSpellIcon( 107574 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 90,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 6,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS},
        _priority = 1500,
        _duration = 20
    },
    ["deadlyCalm"] = {
        id = 262228,
        name = HoJ:GetSpellName( 262228 ),
        rank = HoJ:GetSpellRank( 262228 ),
        icon = HoJ:GetSpellIcon( 262228 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 90,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 6,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS }
    },
    ["ravager"] = {
        id = 152277,
        name = HoJ:GetSpellName( 152277 ),
        rank = HoJ:GetSpellRank( 152277 ),
        icon = HoJ:GetSpellIcon( 152277 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 90,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_8_YARDS,
        talentRow = 7,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS }
    },
    ["siegebreaker"] = {
        id = 280772,
        name = HoJ:GetSpellName( 280772 ),
        rank = HoJ:GetSpellRank( 280772 ),
        icon = HoJ:GetSpellIcon( 280772 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _powerGen = 10,
        range = HoJ.RANGE_MELEE,
        talentRow = 7,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    ["bladestorm"] = {
        id = 46924,
        name = HoJ:GetSpellName( 46924 ),
        rank = HoJ:GetSpellRank( 46924 ),
        icon = HoJ:GetSpellIcon( 46924 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 90,
        cooldownRemaining = 0,
        _powerGen = 25,
        range = HoJ.RANGE_8_YARDS,
        talentRow = 6,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    ["dragonRoar"] = {
        id = 118000,
        name = HoJ:GetSpellName( 118000 ),
        rank = HoJ:GetSpellRank( 118000 ),
        icon = HoJ:GetSpellIcon( 118000 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 90,
        cooldownRemaining = 0,
        _priority = 500,
        _powerGen = 25,
        range = HoJ.RANGE_12_YARDS,
        talentRow = 6,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_WARRIOR_FURY }
    },
    -- buffs
    ["rallyingCry"] = {
        id = 97462,
        name = HoJ:GetSpellName( 97462 ),
        rank = HoJ:GetSpellRank( 97462 ),
        icon = HoJ:GetSpellIcon( 97462 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        buffDurationSeconds = 600,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 80,
        cooldownRemaining = 0,
        _priority = 800,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS, HoJ.SPEC_WARRIOR_FURY, HoJ.SPEC_WARRIOR_PROTECTION }
    },
    ["victorious"] = {
        id = 32216,
        name = HoJ:GetSpellName( 32216 ),
        rank = HoJ:GetSpellRank( 32216 ),
        icon = HoJ:GetSpellIcon( 32216 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        buffDurationSeconds = 20000,
        isProcd = true,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 80,
        cooldownRemaining = 0,
        _priority = 1000,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS, HoJ.SPEC_WARRIOR_FURY, HoJ.SPEC_WARRIOR_PROTECTION }
    },
    -- racials
    ["stoneform"] = {
        id = 20594,
        name = HoJ:GetSpellName( 20594 ),
        rank = HoJ:GetSpellRank( 20594 ),
        icon = HoJ:GetSpellIcon( 20594 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        buffDurationSeconds = 600,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 80,
        cooldownRemaining = 0,
        _priority = 900,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS, HoJ.SPEC_WARRIOR_FURY, HoJ.SPEC_WARRIOR_PROTECTION }
    },
    -- arms
    ["mortalWoundsDebuff"] = {
        id = 115804,
        name = HoJ:GetSpellName( 115804 ),
        rank = HoJ:GetSpellRank( 115804 ),
        icon = HoJ:GetSpellIcon( 115804 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = true,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _priority = 900,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 3,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS },
        _duration = 10,
        _showStacks = true,
    },
    ["deepWoundsDebuff"] = {
        id = 262115,
        name = HoJ:GetSpellName( 262115 ),
        rank = HoJ:GetSpellRank( 262115 ),
        icon = HoJ:GetSpellIcon( 262115 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = true,
        text = nil,
        minLevel = 55,
        cooldownRemaining = 0,
        _priority = 900,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 3,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_ARMS },
        _duration = 10,
        _showStacks = true,
    },
    -- protection warrior
    ["shieldBlock"] = {
        id = 2565,
        name = HoJ:GetSpellName( 2565 ),
        rank = HoJ:GetSpellRank( 2565 ),
        icon = HoJ:GetSpellIcon( 2565 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _priority = 1000,
        _powerGen = -30,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = true,
    },
    ["shieldSlam"] = {
        id = 23922,
        name = HoJ:GetSpellName( 23922 ),
        rank = HoJ:GetSpellRank( 23922 ),
        icon = HoJ:GetSpellIcon( 23922 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = false,
    },
    ["devastate"] = {
        id = 20243,
        name = HoJ:GetSpellName( 20243 ),
        rank = HoJ:GetSpellRank( 20243 ),
        icon = HoJ:GetSpellIcon( 20243 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = false,
    },
    ["revenge"] = {
        id = 6572,
        name = HoJ:GetSpellName( 6572 ),
        rank = HoJ:GetSpellRank( 6572 ),
        icon = HoJ:GetSpellIcon( 6572 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 22,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 15,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = false,
    },
    ["revengeBuff"] = {
        id = 5302,
        name = HoJ:GetSpellName( 5302 ),
        rank = HoJ:GetSpellRank( 5302 ),
        icon = HoJ:GetSpellIcon( 5302 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 0,
        cooldownRemaining = 0,
        _priority = 900,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _duration = 6,
        _showStacks = false,
    },
    ["shockwave"] = {
        id = 46968,
        name = HoJ:GetSpellName( 46968 ),
        rank = HoJ:GetSpellRank( 46968 ),
        icon = HoJ:GetSpellIcon( 46968 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 0,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_10_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = false,
    },
    ["intercept"] = {
        id = 198304,
        name = HoJ:GetSpellName( 198304 ),
        rank = HoJ:GetSpellRank( 198304 ),
        icon = HoJ:GetSpellIcon( 198304 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 28,
        cooldownRemaining = 0,
        _powerGen = 15,
        range = HoJ.RANGE_25_YARDS, -- min 8 yards against enemies
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = true,
    },
    ["thunderClap"] = {
        id = 6343,
        name = HoJ:GetSpellName( 6343 ),
        rank = HoJ:GetSpellRank( 6343 ),
        icon = HoJ:GetSpellIcon( 6343 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 14,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 5,
        range = HoJ.RANGE_8_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = false,
    },
    ["ignorePain"] = {
        id = 190456,
        name = HoJ:GetSpellName( 190456 ),
        rank = HoJ:GetSpellRank( 190456 ),
        icon = HoJ:GetSpellIcon( 190456 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 36,
        cooldownRemaining = 0,
        _priority = 1800,
        _powerGen = -40,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = false,
    },
    ["shieldWall"] = {
        id = 871,
        name = HoJ:GetSpellName( 871 ),
        rank = HoJ:GetSpellRank( 871 ),
        icon = HoJ:GetSpellIcon( 871 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 55,
        cooldownRemaining = 0,
        _priority = 1900,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = false,
    },
    ["spellReflection"] = {
        id = 23920,
        name = HoJ:GetSpellName( 23920 ),
        rank = HoJ:GetSpellRank( 23920 ),
        icon = HoJ:GetSpellIcon( 23920 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 70,
        cooldownRemaining = 0,
        _priority = 1100,
        _powerGen = 0,
        range = HoJ.RANGE_8_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = false,
    },
    ["lastStand"] = {
        id = 12975,
        name = HoJ:GetSpellName( 12975 ),
        rank = HoJ:GetSpellRank( 12975 ),
        icon = HoJ:GetSpellIcon( 12975 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 32,
        cooldownRemaining = 0,
        _priority = 2000,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = false,
    },
    ["demoralizingShout"] = {
        id = 1160,
        name = HoJ:GetSpellName( 1160 ),
        rank = HoJ:GetSpellRank( 1160 ),
        icon = HoJ:GetSpellIcon( 1160 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 48,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_10_YARDS,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = false,
    },
    ["boomingVoice"] = {
        id = 202743,
        name = HoJ:GetSpellName( 202743 ),
        rank = HoJ:GetSpellRank( 202743 ),
        icon = HoJ:GetSpellIcon( 202743 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 90,
        cooldownRemaining = 0,
        _priority = 500,
        _powerGen = 25,
        range = HoJ.RANGE_12_YARDS,
        talentRow = 6,
        talentCol = 1,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION }
    },
    ["demoralizingShoutWithBoomingVoice"] = {
        id = 1160,
        name = HoJ:GetSpellName( 1160 ),
        rank = HoJ:GetSpellRank( 1160 ),
        icon = HoJ:GetSpellIcon( 1160 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 0,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 40,
        range = HoJ.RANGE_10_YARDS,
        talentRow = 6,
        talentCol = 1,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _showStacks = false,
    },
    ["protAvatar"] = { -- Avatar is not a talent for protection, but a skill
        id = 107574,
        name = HoJ:GetSpellName( 107574 ),
        rank = HoJ:GetSpellRank( 107574 ),
        icon = HoJ:GetSpellIcon( 107574 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION },
        _priority = 1500,
        _duration = 20
    },
    ["protImpendingVictory"] = {
        id = 202168,
        name = HoJ:GetSpellName( 202168 ),
        rank = HoJ:GetSpellRank( 202168 ),
        icon = HoJ:GetSpellIcon( 202168 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _powerGen = -10,
        range = HoJ.RANGE_MELEE,
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION }
    },
    ["shieldBlockBuff"] = {
        id = 132404,
        name = HoJ:GetSpellName( 132404 ),
        rank = HoJ:GetSpellRank( 132404 ),
        icon = HoJ:GetSpellIcon( 132404 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _priority = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF
    },
    ["protStormBolt"] = {
        id = 107570,
        name = HoJ:GetSpellName( 107570 ),
        rank = HoJ:GetSpellRank( 107570 ),
        icon = HoJ:GetSpellIcon( 107570 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 30,
        cooldownRemaining = 0,
        _priority = 700,
        _powerGen = 0,
        range = HoJ.RANGE_20_YARDS,
        talentRow = 5,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION  }
    },
    ["protDragonRoar"] = {
        id = 118000,
        name = HoJ:GetSpellName( 118000 ),
        rank = HoJ:GetSpellRank( 118000 ),
        icon = HoJ:GetSpellIcon( 118000 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 90,
        cooldownRemaining = 0,
        _priority = 500,
        _powerGen = 25,
        range = HoJ.RANGE_12_YARDS,
        talentRow = 3,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION }
    },
    ["protRavager"] = {
        id = 228920,
        name = HoJ:GetSpellName( 228920 ),
        rank = HoJ:GetSpellRank( 228920 ),
        icon = HoJ:GetSpellIcon( 228920 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 90,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_8_YARDS,
        talentRow = 7,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_WARRIOR_PROTECTION }
    },
}

-- -------------------------------------------------------------
-- ROGUE
-- -------------------------------------------------------------
HoJ._rogueSpellInfos = {
    ["globalCooldown"] = {
        id = 61304,
        name = HoJ:GetSpellName( 61304 ),
        rank = HoJ:GetSpellRank( 61304 ),
        icon = HoJ:GetSpellIcon( 61304 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_NONE,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["sinisterStrike"] = {
        id = 1752,
        name = HoJ:GetSpellName( 1752 ),
        rank = HoJ:GetSpellRank( 1752 ),
        icon = HoJ:GetSpellIcon( 1752 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 1,
        cooldownRemaining = 0,
        _powerGen = -45,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["eviscerate"] = {
        id = 196819,
        name = HoJ:GetSpellName( 196819 ),
        rank = HoJ:GetSpellRank( 196819 ),
        icon = HoJ:GetSpellIcon( 196819 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 3,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = -6,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["stealth"] = {
        id = 1784,
        name = HoJ:GetSpellName( 1784 ),
        rank = HoJ:GetSpellRank( 1784 ),
        icon = HoJ:GetSpellIcon( 1784 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 5,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = -6,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["cheapShot"] = {
        id = 1833,
        name = HoJ:GetSpellName( 1833 ),
        rank = HoJ:GetSpellRank( 1833 ),
        icon = HoJ:GetSpellIcon( 1833 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 8,
        cooldownRemaining = 0,
        _powerGen = -40,
        _comboGen = 2,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_REQUIRED
    },
    ["deadlyPoison"] = {
        id = 2823,
        name = HoJ:GetSpellName( 2823 ),
        rank = HoJ:GetSpellRank( 2823 ),
        icon = HoJ:GetSpellIcon( 2823 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["poisonedKnife"] = {
        id = 185565,
        name = HoJ:GetSpellName( 185565 ),
        rank = HoJ:GetSpellRank( 185565 ),
        icon = HoJ:GetSpellIcon( 185565 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = -40,
        _comboGen = 1,
        range = HoJ.RANGE_30_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["garrote"] = {
        id = 703,
        name = HoJ:GetSpellName( 703 ),
        rank = HoJ:GetSpellRank( 703 ),
        icon = HoJ:GetSpellIcon( 703 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 12,
        cooldownRemaining = 0,
        _powerGen = -45,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["pickPocket"] = {
        id = 921,
        name = HoJ:GetSpellName( 921 ),
        rank = HoJ:GetSpellRank( 921 ),
        icon = HoJ:GetSpellIcon( 921 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 13,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_10_YARDS,
        _stealth = HoJ.STEALTH_REQUIRED
    },
    ["sap"] = {
        id = 6770,
        name = HoJ:GetSpellName( 6770 ),
        rank = HoJ:GetSpellRank( 6770 ),
        icon = HoJ:GetSpellIcon( 6770 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 13,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 0,
        range = HoJ.RANGE_10_YARDS,
        _stealth = HoJ.STEALTH_REQUIRED
    },
    ["crimsonVial"] = {
        id = 185311,
        name = HoJ:GetSpellName( 185311 ),
        rank = HoJ:GetSpellRank( 185311 ),
        icon = HoJ:GetSpellIcon( 185311 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 16,
        cooldownRemaining = 0,
        _powerGen = -30,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["kick"] = {
        id = 1766,
        name = HoJ:GetSpellName( 1766 ),
        rank = HoJ:GetSpellRank( 1766 ),
        icon = HoJ:GetSpellIcon( 1766 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 18,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["rupture"] = {
        id = 1943,
        name = HoJ:GetSpellName( 1943 ),
        rank = HoJ:GetSpellRank( 1943 ),
        icon = HoJ:GetSpellIcon( 1943 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _powerGen = -25,
        _comboGen = -5,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["shadowstep"] = {
        id = 36554,
        name = HoJ:GetSpellName( 36554 ),
        rank = HoJ:GetSpellRank( 36554 ),
        icon = HoJ:GetSpellIcon( 36554 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 22,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_25_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["blind"] = {
        id = 2094,
        name = HoJ:GetSpellName( 2094 ),
        rank = HoJ:GetSpellRank( 2094 ),
        icon = HoJ:GetSpellIcon( 2094 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 24,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_15_YARDS,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["pickLock"] = {
        id = 1804,
        name = HoJ:GetSpellName( 1804 ),
        rank = HoJ:GetSpellRank( 1804 ),
        icon = HoJ:GetSpellIcon( 1804 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 26,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["evasion"] = {
        id = 5277,
        name = HoJ:GetSpellName( 5277 ),
        rank = HoJ:GetSpellRank( 5277 ),
        icon = HoJ:GetSpellIcon( 5277 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 26,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["sprint"] = {
        id = 2983,
        name = HoJ:GetSpellName( 2983 ),
        rank = HoJ:GetSpellRank( 2983 ),
        icon = HoJ:GetSpellIcon( 2983 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 32,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["kidneyShot"] = {
        id = 408,
        name = HoJ:GetSpellName( 408 ),
        rank = HoJ:GetSpellRank( 408 ),
        icon = HoJ:GetSpellIcon( 408 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = -25,
        _comboGen = -5,
        range = HoJ.RANGE_MELEE,
        _requiresStealth = false,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["distract"] = {
        id = 1725,
        name = HoJ:GetSpellName( 1725 ),
        rank = HoJ:GetSpellRank( 1725 ),
        icon = HoJ:GetSpellIcon( 1725 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 38,
        cooldownRemaining = 0,
        _powerGen = -30,
        _comboGen = 0,
        range = HoJ.RANGE_30_YARDS,
        _stealth = HoJ.STEALTH_REQUIRED
    },
    ["cripplingPoison"] = {
        id = 3408,
        name = HoJ:GetSpellName( 3408 ),
        rank = HoJ:GetSpellRank( 3408 ),
        icon = HoJ:GetSpellIcon( 3408 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 38,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["mutilate"] = {
        id = 53,
        name = HoJ:GetSpellName( 53 ),
        rank = HoJ:GetSpellRank( 53 ),
        icon = HoJ:GetSpellIcon( 53 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = -50,
        _comboGen = 2,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["feint"] = {
        id = 1966,
        name = HoJ:GetSpellName( 1966 ),
        rank = HoJ:GetSpellRank( 1966 ),
        icon = HoJ:GetSpellIcon( 1966 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 44,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["vanish"] = {
        id = 1856,
        name = HoJ:GetSpellName( 1856 ),
        rank = HoJ:GetSpellRank( 1856 ),
        icon = HoJ:GetSpellIcon( 1856 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["woundPoison"] = {
        id = 8679,
        name = HoJ:GetSpellName( 8679 ),
        rank = HoJ:GetSpellRank( 8679 ),
        icon = HoJ:GetSpellIcon( 8679 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 54,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["vendetta"] = {
        id = 79140,
        name = HoJ:GetSpellName( 79140 ),
        rank = HoJ:GetSpellRank( 79140 ),
        icon = HoJ:GetSpellIcon( 79140 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 56,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_30_YARDS,
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["fanOfKnives"] = {
        id = 51723,
        name = HoJ:GetSpellName( 51723 ),
        rank = HoJ:GetSpellRank( 51723 ),
        icon = HoJ:GetSpellIcon( 51723 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 63,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 1,
        range = HoJ.RANGE_10_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
    },
    ["shroudOfConcealment"] = {
        id = 114018,
        name = HoJ:GetSpellName( 114018 ),
        rank = HoJ:GetSpellRank( 114018 ),
        icon = HoJ:GetSpellIcon( 114018 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 68,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_30_YARDS,
        _stealth = HoJ.STEALTH_REQUIRED,
    },
    ["tricksOfTheTrade"] = {
        id = 57934,
        name = HoJ:GetSpellName( 57934 ),
        rank = HoJ:GetSpellRank( 57934 ),
        icon = HoJ:GetSpellIcon( 57934 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 70,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_100_YARDS,
        _stealth = HoJ.STEALTH_ALLOWED,
    },
    ["cloakOfShadows"] = {
        id = 31224,
        name = HoJ:GetSpellName( 31224 ),
        rank = HoJ:GetSpellRank( 31224 ),
        icon = HoJ:GetSpellIcon( 31224 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 80,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED
    },
    ["backstab"] = {
        id = 53,
        name = HoJ:GetSpellName( 53 ),
        rank = HoJ:GetSpellRank( 53 ),
        icon = HoJ:GetSpellIcon( 53 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 2,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_ALLOWED,
    },
    ["shurikenToss"] = {
        id = 114014,
        name = HoJ:GetSpellName( 114014 ),
        rank = HoJ:GetSpellRank( 114014 ),
        icon = HoJ:GetSpellIcon( 114014 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 10,
        cooldownRemaining = 0,
        _powerGen = -40,
        _comboGen = 1,
        range = HoJ.RANGE_30_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
    },
    ["shadowstrike"] = {
        id = 185438,
        name = HoJ:GetSpellName( 185438 ),
        rank = HoJ:GetSpellRank( 185438 ),
        icon = HoJ:GetSpellIcon( 185438 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 12,
        cooldownRemaining = 0,
        _powerGen = -40,
        _comboGen = 2,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_REQUIRED,
    },
    ["nightblade"] = {
        id = 195452,
        name = HoJ:GetSpellName( 195452 ),
        rank = HoJ:GetSpellRank( 195452 ),
        icon = HoJ:GetSpellIcon( 195452 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _powerGen = -25,
        _comboGen = 1,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
    },
    ["nightbladeDebuff"] = {
        id = 195452,
        name = HoJ:GetSpellName( 195452 ),
        rank = HoJ:GetSpellRank( 195452 ),
        icon = HoJ:GetSpellIcon( 195452 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 20,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_MELEE,
        _stealth = HoJ.STEALTH_DISALLOWED,
        _durationForComboPoints = {
            8,
            10,
            12,
            14,
            16,
            18
        }
    },
    ["symbolsOfDeath"] = {
        id = 212283,
        name = HoJ:GetSpellName( 212283 ),
        rank = HoJ:GetSpellRank( 212283 ),
        icon = HoJ:GetSpellIcon( 212283 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 36,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
    },
    ["symbolsOfDeathBuff"] = {
        id = 212283,
        name = HoJ:GetSpellName( 212283 ),
        rank = HoJ:GetSpellRank( 212283 ),
        icon = HoJ:GetSpellIcon( 212283 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 36,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
    },
    ["shadowDance"] = {
        id = 185313,
        name = HoJ:GetSpellName( 185313 ),
        rank = HoJ:GetSpellRank( 185313 ),
        icon = HoJ:GetSpellIcon( 185313 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_DISALLOWED,
    },
    ["shadowDanceBuff"] = {
        id = 185422,
        name = HoJ:GetSpellName( 185422 ),
        rank = HoJ:GetSpellRank( 185422 ),
        icon = HoJ:GetSpellIcon( 185422 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 40,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
    },
    ["shadowstrike2"] = {
        id = 231718,
        name = HoJ:GetSpellName( 231718 ),
        rank = HoJ:GetSpellRank( 231718 ),
        icon = HoJ:GetSpellIcon( 231718 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 12,
        cooldownRemaining = 0,
        _powerGen = -40,
        _comboGen = 2,
        range = HoJ.RANGE_25_YARDS,
        _stealth = HoJ.STEALTH_REQUIRED,
    },
    ["shadowBlades"] = {
        id = 121471,
        name = HoJ:GetSpellName( 121471 ),
        rank = HoJ:GetSpellRank( 121471 ),
        icon = HoJ:GetSpellIcon( 121471 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 56,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        _stealth = HoJ.STEALTH_ALLOWED,
    },
    ["shurikenStorm"] = {
        id = 197835,
        name = HoJ:GetSpellName( 197835 ),
        rank = HoJ:GetSpellRank( 197835 ),
        icon = HoJ:GetSpellIcon( 197835 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 66,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 1,
        range = HoJ.RANGE_10_YARDS,
        _stealth = HoJ.STEALTH_DISALLOWED,
    },
    ["gloomblade"] = {
        id = 200758,
        name = HoJ:GetSpellName( 200758 ),
        rank = HoJ:GetSpellRank( 200758 ),
        icon = HoJ:GetSpellIcon( 200758 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 15,
        cooldownRemaining = 0,
        _powerGen = -35,
        _comboGen = 1,
        range = HoJ.RANGE_8_YARDS,
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["markedForDeath"] = {
        id = 137619,
        name = HoJ:GetSpellName( 137619 ),
        rank = HoJ:GetSpellRank( 137619 ),
        icon = HoJ:GetSpellIcon( 137619 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_30_YARDS,
        talentRow = 3,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["deeperStrategem"] = {
        id = 193531,
        name = HoJ:GetSpellName( 193531 ),
        rank = HoJ:GetSpellRank( 193531 ),
        icon = HoJ:GetSpellIcon( 193531 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 45,
        cooldownRemaining = 0,
        _powerGen = 0,
        _comboGen = 0,
        range = HoJ.RANGE_SELF,
        talentRow = 3,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["secretTechnique"] = {
        id = 280719,
        name = HoJ:GetSpellName( 280719 ),
        rank = HoJ:GetSpellRank( 280719 ),
        icon = HoJ:GetSpellIcon( 280719 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _powerGen = -30,
        _comboGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 7,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
        _stealth = HoJ.STEALTH_ALLOWED
    },
    ["shurikenTornado"] = {
        id = 277925,
        name = HoJ:GetSpellName( 277925 ),
        rank = HoJ:GetSpellRank( 277925 ),
        icon = HoJ:GetSpellIcon( 277925 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _powerGen = -60,
        _comboGen = 0,
        range = HoJ.RANGE_10_YARDS,
        talentRow = 7,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_ROGUE_SUBTLETY },
        _stealth = HoJ.STEALTH_ALLOWED
    },
}

-- -------------------------------------------------------------
-- DEMON HUNTER
-- -------------------------------------------------------------
HoJ._demonHunterSpellInfos = {
    ["globalCooldown"] = {
        id = 61304,
        name = HoJ:GetSpellName( 61304 ),
        rank = HoJ:GetSpellRank( 61304 ),
        icon = HoJ:GetSpellIcon( 61304 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = false,
        showCheckbox = false,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_NONE,
    },
    ["consumeMagic"] = {
        id = 278326,
        name = HoJ:GetSpellName( 278326 ),
        rank = HoJ:GetSpellRank( 278326 ),
        icon = HoJ:GetSpellIcon( 278326 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 20,
        range = HoJ.RANGE_30_YARDS,
    },
    -- havoc
    ["demonsBite"] = {
        id = 162243,
        name = HoJ:GetSpellName( 162243 ),
        rank = HoJ:GetSpellRank( 162243 ),
        icon = HoJ:GetSpellIcon( 162243 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 30,
        range = HoJ.RANGE_MELEE,
    },
    ["chaosStrike"] = {
        id = 162794,
        name = HoJ:GetSpellName( 162794 ),
        rank = HoJ:GetSpellRank( 162794 ),
        icon = HoJ:GetSpellIcon( 162794 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = -40,
        range = HoJ.RANGE_MELEE,
    },
    ["eyeBeam"] = {
        id = 198013,
        name = HoJ:GetSpellName( 198013 ),
        rank = HoJ:GetSpellRank( 198013 ),
        icon = HoJ:GetSpellIcon( 198013 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = -30,
        range = HoJ.RANGE_20_YARDS,
    },
    ["bladeDance"] = {
        id = 188499,
        name = HoJ:GetSpellName( 188499 ),
        rank = HoJ:GetSpellRank( 188499 ),
        icon = HoJ:GetSpellIcon( 188499 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = -15,
        range = HoJ.RANGE_15_YARDS,
    },
    ["deathSweep"] = {
        id = 210152,
        name = HoJ:GetSpellName( 210152 ),
        rank = HoJ:GetSpellRank( 210152 ),
        icon = HoJ:GetSpellIcon( 210152 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = -35,
        range = HoJ.RANGE_10_YARDS,
    },
    ["throwGlaive"] = {
        id = 185123,
        name = HoJ:GetSpellName( 185123 ),
        rank = HoJ:GetSpellRank( 185123 ),
        icon = HoJ:GetSpellIcon( 185123 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["felRush"] = {
        id = 195072,
        name = HoJ:GetSpellName( 195072 ),
        rank = HoJ:GetSpellRank( 195072 ),
        icon = HoJ:GetSpellIcon( 195072 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_20_YARDS,
    },
    ["metamorphosis"] = {
        id = 191427,
        name = HoJ:GetSpellName( 191427 ),
        rank = HoJ:GetSpellRank( 191427 ),
        icon = HoJ:GetSpellIcon( 191427 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 30,
        range = HoJ.RANGE_SELF,
    },
    ["metamorphosisBuff"] = {
        id = 162264,
        name = HoJ:GetSpellName( 162264 ),
        rank = HoJ:GetSpellRank( 162264 ),
        icon = HoJ:GetSpellIcon( 162264 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["disrupt"] = {
        id = 183752,
        name = HoJ:GetSpellName( 183752 ),
        rank = HoJ:GetSpellRank( 183752 ),
        icon = HoJ:GetSpellIcon( 183752 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 30,
        range = HoJ.RANGE_MELEE,
    },
    ["vengefulRetreat"] = {
        id = 198793,
        name = HoJ:GetSpellName( 198793 ),
        rank = HoJ:GetSpellRank( 198793 ),
        icon = HoJ:GetSpellIcon( 198793 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["blur"] = {
        id = 198589,
        name = HoJ:GetSpellName( 198589 ),
        rank = HoJ:GetSpellRank( 198589 ),
        icon = HoJ:GetSpellIcon( 198589 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
    },
    ["comsumeMagic"] = {
        id = 278326,
        name = HoJ:GetSpellName( 278326 ),
        rank = HoJ:GetSpellRank( 278326 ),
        icon = HoJ:GetSpellIcon( 278326 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["blurBuff"] = {
        id = 212800,
        name = HoJ:GetSpellName( 212800 ),
        rank = HoJ:GetSpellRank( 212800 ),
        icon = HoJ:GetSpellIcon( 212800 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["imprison"] = {
        id = 217832,
        name = HoJ:GetSpellName( 217832 ),
        rank = HoJ:GetSpellRank( 217832 ),
        icon = HoJ:GetSpellIcon( 217832 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_20_YARDS,
        _creatureTypes = { ["Demon"] = true, ["Beast"] = true, ["Humanoid"] = true }
    },
    -- havoc talents
    ["fellblade"] = {
        id = 232893,
        name = HoJ:GetSpellName( 232893 ),
        rank = HoJ:GetSpellRank( 232893 ),
        icon = HoJ:GetSpellIcon( 232893 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 99,
        cooldownRemaining = 0,
        _powerGen = 40,
        range = HoJ.RANGE_15_YARDS,
        talentRow = 1,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_HAVOC },
    },
    ["demonBlades"] = {
        id = 203555,
        name = HoJ:GetSpellName( 203555 ),
        rank = HoJ:GetSpellRank( 203555 ),
        icon = HoJ:GetSpellIcon( 203555 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _powerGen = 30,
        range = HoJ.RANGE_MELEE,
        talentRow = 2,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_HAVOC },
    },
    ["immolationAura"] = {
        id = 258920,
        name = HoJ:GetSpellName( 258920 ),
        rank = HoJ:GetSpellRank( 258920 ),
        icon = HoJ:GetSpellIcon( 258920 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 100,
        cooldownRemaining = 0,
        _powerGen = 30,
        range = HoJ.RANGE_MELEE,
        talentRow = 2,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_HAVOC },
    },
    ["nemesis"] = {
        id = 206491,
        name = HoJ:GetSpellName( 206491 ),
        rank = HoJ:GetSpellRank( 206491 ),
        icon = HoJ:GetSpellIcon( 206491 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 110,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS, -- actually 50 yards
        talentRow = 7,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_HAVOC },
    },
    -- vengeance
    -- SLREMOVE
--[[
    ["vengeanceImmolationAura"] = {
        id = 178740,
        name = HoJ:GetSpellName( 178740 ),
        rank = HoJ:GetSpellRank( 178740 ),
        icon = HoJ:GetSpellIcon( 178740 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 20,
        range = HoJ.RANGE_8_YARDS,
    },
--]]
    ["soulCleave"] = {
        id = 228477,
        name = HoJ:GetSpellName( 228477 ),
        rank = HoJ:GetSpellRank( 228477 ),
        icon = HoJ:GetSpellIcon( 228477 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = -30,
        range = HoJ.RANGE_MELEE,
    },
    ["sigilOfFlame"] = {
        id = 204596,
        name = HoJ:GetSpellName( 204596 ),
        rank = HoJ:GetSpellRank( 204596 ),
        icon = HoJ:GetSpellIcon( 204596 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 20,
        range = HoJ.RANGE_30_YARDS,
    },
    ["shear"] = {
        id = 203783,
        name = HoJ:GetSpellName( 203783 ),
        rank = HoJ:GetSpellRank( 203783 ),
        icon = HoJ:GetSpellIcon( 203783 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 10,
        range = HoJ.RANGE_MELEE,
    },
    ["vengeanceThrowGlaive"] = {
        id = 204157,
        name = HoJ:GetSpellName( 204157 ),
        rank = HoJ:GetSpellRank( 204157 ),
        icon = HoJ:GetSpellIcon( 204157 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["vengeanceMetamorphosis"] = {
        id = 187827,
        name = HoJ:GetSpellName( 187827 ),
        rank = HoJ:GetSpellRank( 187827 ),
        icon = HoJ:GetSpellIcon( 187827 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 105,
        range = HoJ.RANGE_SELF,
    },
    ["vengeanceMetamorphosisBuff"] = {
        id = 187827,
        name = HoJ:GetSpellName( 187827 ),
        rank = HoJ:GetSpellRank( 187827 ),
        icon = HoJ:GetSpellIcon( 187827 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["infernalStrike"] = {
        id = 189110,
        name = HoJ:GetSpellName( 189110 ),
        rank = HoJ:GetSpellRank( 189110 ),
        icon = HoJ:GetSpellIcon( 189110 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_40_YARDS,
    },
    ["sigilOfMisery"] = {
        id = 207684,
        name = HoJ:GetSpellName( 207684 ),
        rank = HoJ:GetSpellRank( 207684 ),
        icon = HoJ:GetSpellIcon( 207684 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["sigilOfSilence"] = {
        id = 202137,
        name = HoJ:GetSpellName( 202137 ),
        rank = HoJ:GetSpellRank( 202137 ),
        icon = HoJ:GetSpellIcon( 202137 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["fieryBrand"] = {
        id = 204021,
        name = HoJ:GetSpellName( 204021 ),
        rank = HoJ:GetSpellRank( 204021 ),
        icon = HoJ:GetSpellIcon( 204021 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
    },
    ["demonSpikes"] = {
        id = 203720,
        name = HoJ:GetSpellName( 203720 ),
        rank = HoJ:GetSpellRank( 203720 ),
        icon = HoJ:GetSpellIcon( 203720 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_SKILL,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    ["demonSpikesBuff"] = {
        id = 203819,
        name = HoJ:GetSpellName( 203819 ),
        rank = HoJ:GetSpellRank( 203819 ),
        icon = HoJ:GetSpellIcon( 203819 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
    },
    -- vengeance talents
    ["fracture"] = {
        id = 263642,
        name = HoJ:GetSpellName( 263642 ),
        rank = HoJ:GetSpellRank( 263642 ),
        icon = HoJ:GetSpellIcon( 263642 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 104,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_MELEE,
        talentRow = 4,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_VENGEANCE },
    },
    ["sigilOfChains"] = {
        id = 202138,
        name = HoJ:GetSpellName( 202138 ),
        rank = HoJ:GetSpellRank( 202138 ),
        icon = HoJ:GetSpellIcon( 202138 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 106,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_30_YARDS,
        talentRow = 5,
        talentCol = 3,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_VENGEANCE },
    },
    ["spiritBomb"] = {
        id = 247454,
        name = HoJ:GetSpellName( 247454 ),
        rank = HoJ:GetSpellRank( 247454 ),
        icon = HoJ:GetSpellIcon( 247454 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_TALENT,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = false,
        text = nil,
        minLevel = 108,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_25_YARDS,
        talentRow = 6,
        talentCol = 2,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_VENGEANCE },
    },
    ["soulFragments"] = {
        id = 203981,
        name = HoJ:GetSpellName( 203981 ),
        rank = HoJ:GetSpellRank( 203981 ),
        icon = HoJ:GetSpellIcon( 203981 ),
        spellIndex = -1,
        spellType = HoJ.SPELL_BUFF,
        isProcd = false,
        showOnBar = true,
        showCheckbox = true,
        showCharges = true,
        text = nil,
        minLevel = 98,
        cooldownRemaining = 0,
        _powerGen = 0,
        range = HoJ.RANGE_SELF,
        _duration = 20,
        _talentSpecs = { HoJ.SPEC_DEMONHUNTER_VENGEANCE },
        _castBySpellId = 203981,
    },
}